--2021.01.26 v1.00
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity d7seg_ctrl is
    Port ( clk : in STD_LOGIC;
           reset : in STD_LOGIC;	
           count : in STD_LOGIC_VECTOR(15 downto 0);	
           keta : out STD_LOGIC_VECTOR(3 downto 0);	
           data_7seg : out STD_LOGIC_VECTOR(6 downto 0));	
end d7seg_ctrl;

architecture Behavioral of d7seg_ctrl is
  signal timing_cnt :STD_LOGIC_VECTOR(15 downto 0); --IJE^
  signal timing_sig :STD_LOGIC; --ؑփ^C~O
  signal keta_cnt :STD_LOGIC_VECTOR(1 downto 0); --JE^
  signal sel_cnt:STD_LOGIC_VECTOR(3 downto 0); --\16i
  --16i>7ZO\p^[ϊ֐
  function hex2seg ( data : STD_LOGIC_VECTOR(3 downto 0)) 
  return STD_LOGIC_VECTOR  is
    variable seg_data : STD_LOGIC_VECTOR(6 downto 0);
  begin
    case data is
      when "0000" => seg_data := "1000000" ;
      when "0001" => seg_data := "1111001" ;
      when "0010" => seg_data := "0100100" ;
      when "0011" => seg_data := "0110000" ;
      when "0100" => seg_data := "0011001" ;
      when "0101" => seg_data := "0010010" ;
      when "0110" => seg_data := "0000010" ;
      when "0111" => seg_data := "1111000" ;
      when "1000" => seg_data := "0000000" ;
      when "1001" => seg_data := "0011000" ;
      when "1010" => seg_data := "0001000" ;
      when "1011" => seg_data := "0000011" ;
      when "1100" => seg_data := "1000110" ;
      when "1101" => seg_data := "0100001" ;
      when "1110" => seg_data := "0000110" ;
      when "1111" => seg_data := "0001110" ;
      when others =>  seg_data := "XXXXXXX" ;
    end case;
  return seg_data;      
end;
begin
  --IJE^	
  process(clk,reset) begin
    if(reset='1') then
      timing_cnt <= X"0000";
    else
      if clk'event and clk='1' then
        timing_cnt <=  timing_cnt + X"0001";
      end if;
    end if;
  end process;  
  	
 timing_sig <= '1' when (timing_cnt=X"FFFF") else '0';
 --IJE^
  process(clk,reset) begin
    if (reset='1') then
      keta_cnt <= "00";
    else
      if clk'event and clk='1' then
        if(timing_sig='1') then
          keta_cnt <=  keta_cnt + "01";
        else
          keta_cnt <= keta_cnt;
	    end if;
	  end if;
	end if;
  end process;  
  --f[^I
   with keta_cnt select
     sel_cnt <= count(3 downto 0) when "00",   
                count(7 downto 4) when "01",   
                count(11 downto 8) when "10",   
                count(15 downto 12) when "11", 
                "XXXX" when others;
   --16i->7ZO\p^[ϊ                 
   data_7seg <= hex2seg(sel_cnt);    
   --wMfR[_
   with keta_cnt select
     keta <= "1110" when "00", 
             "1101" when "01", 
             "1011" when "10", 
             "0111" when "11", 
             "XXXX" when others;

end Behavioral;  
