--2021.01.26 v1.00
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity s7seg_ctrl is
    Port ( count : in STD_LOGIC_VECTOR(15 downto 0);
           data0_7seg : out STD_LOGIC_VECTOR(6 downto 0);	
           data1_7seg : out STD_LOGIC_VECTOR(6 downto 0);	
           data2_7seg : out STD_LOGIC_VECTOR(6 downto 0);	
           data3_7seg : out STD_LOGIC_VECTOR(6 downto 0));	
end s7seg_ctrl;

architecture Behavioral of s7seg_ctrl is
  --16i>7ZO\p^[ϊ֐
  function hex2seg (data : STD_LOGIC_VECTOR(3 downto 0) ) return STD_LOGIC_VECTOR is
    variable seg_data : STD_LOGIC_VECTOR(6 downto 0);
  begin
    case data is
      when "0000" => seg_data := "1000000" ;
      when "0001" => seg_data := "1111001" ;
      when "0010" => seg_data := "0100100" ;
      when "0011" => seg_data := "0110000" ;
      when "0100" => seg_data := "0011001" ;
      when "0101" => seg_data := "0010010" ;
      when "0110" => seg_data := "0000010" ;
      when "0111" => seg_data := "1111000" ;
      when "1000" => seg_data := "0000000" ;
      when "1001" => seg_data := "0011000" ;
      when "1010" => seg_data := "0001000" ;
      when "1011" => seg_data := "0000011" ;
      when "1100" => seg_data := "1000110" ;
      when "1101" => seg_data := "0100001" ;
      when "1110" => seg_data := "0000110" ;
      when "1111" => seg_data := "0001110" ; 
      when others => seg_data := "XXXXXXX" ;
    end case;
    return seg_data;
  end;
  begin
  -- e̕ϊ             
    data0_7seg <= hex2seg(count(3 downto 0)); 
    data1_7seg <= hex2seg(count(7 downto 4));    
    data2_7seg <= hex2seg(count(11 downto 8));    
    data3_7seg <= hex2seg(count(15 downto 12));     

end Behavioral;  
